HTTP::Client::Response - Crystal 1.20.3

# class HTTP::Client::Response

- HTTP::Client::Response
- Reference
- Object

##
Defined in:

http/client/response.cr

##
Constructors

- .from_io(io : IO, ignore_body : Bool = false, decompress : Bool = true) : self
- .new(status : HTTP::Status, body : String | Nil = nil, headers : Headers = Headers.new, status_message : String | Nil = nil, version : String = "HTTP/1.1", body_io : IO | Nil = nil)
- .new(status_code : Int32, body : String | Nil = nil, headers : Headers = Headers.new, status_message : String | Nil = nil, version : String = "HTTP/1.1", body_io : IO | Nil = nil) : self

##
Class Method Summary

- .from_io(io, ignore_body = false, decompress = true, &)
- .from_io?(io : IO, ignore_body : Bool = false, decompress : Bool = true) : self | Nil

  Parses an `HTTP::Client::Response` from the given `IO`.

- .from_io?(io, ignore_body = false, decompress = true, &)

  Parses an `HTTP::Client::Response` from the given `IO` and yields it to the block.

- .mandatory_body?(status : HTTP::Status) : Bool
- .supports_chunked?(version : String) : Bool

##
Instance Method Summary

- #body : String
- #body? : String | Nil
- #body_io : IO
- #body_io? : IO | Nil
- #charset : String | Nil
- #content_type : String | Nil
- #cookies : HTTP::Cookies

  Returns a convenience wrapper around querying and setting cookie related headers, see `HTTP::Cookies`.

- #headers : Headers
- #keep_alive? : Bool
- #mime_type : MIME::MediaType | Nil
- #status : HTTP::Status
- #status_code : Int32

  Convenience method to retrieve the HTTP status code.

- #status_message : String | Nil
- #success? : Bool

  Returns `true` if the response status code is between 200 and 299.

- #to_io(io : IO) : Nil
- #version : String

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.from_io(io : IO, ignore_body : Bool = false, decompress : Bool = true) : self #
def self.new(status : HTTP::Status, body : String | Nil = nil, headers : Headers = Headers.new, status_message : String | Nil = nil, version : String = "HTTP/1.1", body_io : IO | Nil = nil) #
def self.new(status_code : Int32, body : String | Nil = nil, headers : Headers = Headers.new, status_message : String | Nil = nil, version : String = "HTTP/1.1", body_io : IO | Nil = nil) : self #

##
Class Method Detail

def self.from_io(io, ignore_body = false, decompress = true, &) #
def self.from_io?(io : IO, ignore_body : Bool = false, decompress : Bool = true) : self | Nil #

Parses an `HTTP::Client::Response` from the given `IO`. Might return `nil` if there's no data in the `IO`, which probably means that the connection was closed.

def self.from_io?(io, ignore_body = false, decompress = true, &) #

Parses an `HTTP::Client::Response` from the given `IO` and yields it to the block. Might yield `nil` if there's no data in the `IO`, which probably means that the connection was closed.

def self.mandatory_body?(status : HTTP::Status) : Bool #
def self.supports_chunked?(version : String) : Bool #

##
Instance Method Detail

def body : String #
def body? : String | Nil #
def body_io : IO #
def body_io? : IO | Nil #
def charset : String | Nil #
def content_type : String | Nil #
def cookies : HTTP::Cookies #

Returns a convenience wrapper around querying and setting cookie related headers, see `HTTP::Cookies`.

def headers : Headers #
def keep_alive? : Bool #
def mime_type : MIME::MediaType | Nil #
def status : HTTP::Status #
def status_code : Int32 #

Convenience method to retrieve the HTTP status code.

def status_message : String | Nil #
def success? : Bool #

Returns `true` if the response status code is between 200 and 299.

def to_io(io : IO) : Nil #
def version : String #